# results from bias_correction.R
# load("C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/results_bias_correction.RData")

par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right

##################################################################
# RMSE
##################################################################
# original model with known WRF/UCM
# rmse.11 = crps.11 = matrix(NA, S.11,1)
# for(i in 1:S.11){
#   rmse.11[i] = rmse( EN.11[,i], y.pred.11[,i] )
#   crps.11[i] = crps( EN.11[,i], cbind(y.pred.11[,i],  sqrt(y.pred.var.11[,i])))$CRPS
# }
# 
# # RMSE-2011
# round(mean(rmse.11, na.rm=T),3)
# round(sd(rmse.11, na.rm=T),3)

# proposed approach
rmse.wrf.11 = crps.wrf.11 = matrix(NA, S.11,1)
for(i in 1:S.11){
  rmse.wrf.11[i] = rmse( EN.11[,i], y.pred.wrf.11[,i] )
  crps.wrf.11[i] = crps( EN.11[,i], cbind(y.pred.wrf.11[,i],  sqrt(y.pred.wrf.var.11[,i])))$CRPS
}

# RMSE-2011
round(mean(rmse.wrf.11, na.rm=T),2)
round(sd(rmse.wrf.11, na.rm=T),2)
round(mean(crps.wrf.11, na.rm=T),2)
round(sd(crps.wrf.11, na.rm=T),2)

# proposed approach
rmse.a.wrf.11 = crps.a.wrf.11 = matrix(NA, S.11,1)
for(i in 1:S.11){
  rmse.a.wrf.11[i] = rmse( EN.11[,i], y.pred.a.wrf.11[,i] )
  crps.a.wrf.11[i] = crps( EN.11[,i], cbind(y.pred.a.wrf.11[,i],  sqrt(y.pred.a.wrf.var.11[,i])))$CRPS
}

# RMSE-2011
round(mean(rmse.a.wrf.11, na.rm=T),2)
round(sd(rmse.a.wrf.11, na.rm=T),2)
round(mean(crps.a.wrf.11, na.rm=T),2)
round(sd(crps.a.wrf.11, na.rm=T),2)


# Low-accuracy model
rmse.low.11 = crps.low.11 = matrix(NA, S.11,1)
for(i in 1:S.11){
  rmse.low.11[i] = rmse( EN.11[,i], WRF.11[,i] )
}

# RMSE-2011
round(mean(rmse.low.11, na.rm=T),2)
round(sd(rmse.low.11, na.rm=T),2)


  
  # lm
  rmse.lm.11 = crps.lm.11 = matrix(NA, S.11,1)
  for(i in 1:S.11){
    rmse.lm.11[i] = rmse( EN.11[,i], y.pred.lm.11[,i] )
    crps.lm.11[i] = crps( EN.11[,i], cbind(y.pred.lm.11[,i],  sqrt(y.pred.lm.var.11[,i])))$CRPS
  }
  
  # RMSE-2011
  round(mean(rmse.lm.11, na.rm=T),2)
  round(sd(rmse.lm.11, na.rm=T),2)
  round(mean(crps.lm.11, na.rm=T),2)
  round(sd(crps.lm.11, na.rm=T),2)




############################################################## 
# prediction interval 
############################################################## 
# original model
# y.pred.11.ub = y.pred.11 + 1.96*sqrt(y.pred.var.11)
# y.pred.11.lb = y.pred.11 - 1.96*sqrt(y.pred.var.11)
# 
# # 95% prediction intervals width
# round(mean(colMeans(y.pred.11.ub - y.pred.11.lb)),2)
# round(sd(colMeans(y.pred.11.ub - y.pred.11.lb)),2)

###################
# Integrative model
y.pred.wrf.11.ub = y.pred.wrf.11 + 1.96*sqrt(y.pred.wrf.var.11)
y.pred.wrf.11.lb = y.pred.wrf.11 - 1.96*sqrt(y.pred.wrf.var.11)

# 95% prediction intervals width
round(mean(colMeans(y.pred.wrf.11.ub - y.pred.wrf.11.lb)),2)
round(sd(colMeans(y.pred.wrf.11.ub - y.pred.wrf.11.lb)),2)

################################################################
## Prediction interval coverage rate (90% and 95%)
################################################################
# original model
# PI.rate.11 = matrix(NA, 1, S.11)
# 
# for (i in 1:S.11){
#   PI.rate.11[i] = sum( ((EN.11[which(is.na(EN.11[,i])==FALSE),i] > y.pred.11.lb[which(is.na(EN.11[,i])==FALSE),i]) &
#                           (EN.11[which(is.na(EN.11[,i])==FALSE),i] < y.pred.11.ub[which(is.na(EN.11[,i])==FALSE),i])) *1)/T * 100
# }
# 
# round(PI.rate.11,2)
# round(mean(PI.rate.11),2)
# round(sd(PI.rate.11),2)





# Integrative model
PI.rate.p2wrf.11 = matrix(NA, 1, S.11)


for (i in 1:S.11){
  PI.rate.p2wrf.11[i] = sum( ((EN.11[,i] > y.pred.wrf.11.lb[,i]) &
                                (EN.11[,i] < y.pred.wrf.11.ub[,i])) *1)/(nT) * 100
}

round(PI.rate.p2wrf.11,2)
round(mean(PI.rate.p2wrf.11),2)
round(sd(PI.rate.p2wrf.11),2)


############################################################## 
# Variability ratio
############################################################## 
# # ratio of the variability, random effects (b0 and b1), and random noise (sigma)
# round(colMeans(ratio.b.11),2)
# round(colMeans(ratio.b.13),2)
# round(colMeans(ratio.b.17),2)
# 
# round(sd(ratio.b.11[,1]),2)
# round(sd(ratio.b.11[,2]),2)
# round(sd(ratio.b.11[,3]),2)
# 
# round(sd(ratio.b.13[,1]),2)
# round(sd(ratio.b.13[,2]),2)
# round(sd(ratio.b.13[,3]),2)
# 
# round(sd(ratio.b.17[,1]),2)
# round(sd(ratio.b.17[,2]),2)
# round(sd(ratio.b.17[,3]),2)
# 
# # ratio of the variability, spatial, temporal, and unstructured variability
# round(colMeans(ratio.st.11),2)
# round(colMeans(ratio.st.13),2)
# round(colMeans(ratio.st.17),2)
# 
# round(sd(ratio.st.11[,1]),2)
# round(sd(ratio.st.11[,2]),2)
# round(sd(ratio.st.11[,3]),2)
# 
# round(sd(ratio.st.13[,1]),2)
# round(sd(ratio.st.13[,2]),2)
# round(sd(ratio.st.13[,3]),2)
# 
# round(sd(ratio.st.17[,1]),2)
# round(sd(ratio.st.17[,2]),2)
# round(sd(ratio.st.17[,3]),2)

############################################################## 
# plot
############################################################## 

for(i in 1:10){
  # pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/pred_vcm_nwp_pred_13_3_v3.pdf",
  # width = 6, # The width of the plot in inches
  # height = 4.5) # The height of the plot in inches
  par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
  plot(EN.11[,i], ylim=c(-10,60), xlab="t", ylab="y", xaxt='n', cex.lab=1.2, cex.axis=1.2, main=i )
  axis(side=1, at=1:nT, labels = c(1:100), cex.axis=1.2  )
  lines(WRF.11[,i], col=4)
  lines(y.pred.wrf.11[,i],  col=2)
  lines(y.pred.wrf.11.ub[,i],  col=2, lty=2)
  lines(y.pred.wrf.11.lb[,i],  col=2, lty=2)
  legend("topleft",legend=c("High-accuracy model", "Low-accracy model","Prediction","95% prediction intervals"), 
         col=c(1,4,2,2,2), lty=c(NA,1,1,2,2), pch=c(21, NA, NA, NA, NA),cex=0.9)
  # dev.off()
}

