# rm(list=ls())
# 
# library(zoo)
# library(tibble)
# library(Metrics)
# library(verification)
# library(fields)
# library(reshape2)
# library(base)
# library(plgp)
# library(ecodist)
# library(mvtnorm)
# library(lhs)
# library(mda)
# library(laGP)
# library(zoo)
# library(Matrix)
# library(optimbase)
eps <- sqrt(.Machine$double.eps) ## defining a small number
# par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right

nl <- function(par, Ds, Y, X){
  n <- length(Y)
  Y = (Y)
  X = as.matrix(cbind(rep(1,n), X))
  length(par)
  
  # spatial correlation: kernel width
  theta.s0 <- par[1]  
  # theta.s1 = par[2]
  
  # temporal correlation: rho
  # rho.0 = par[3]
  # rho.1 = par[4]
  # delta.0_tau2 = par[5]
  # delta.1_tau2 = par[6]
  # 
  # tau2.1_tau2 = par[7]
  g <- par[2]
  
  ################################################################
  # Define the kernel or covariance function
  C0 = exp(-Ds/theta.s0) #+ delta.0_tau2*(rho.0^Dt)/(1-rho.0^2)
  #C1 = tau2.1_tau2 * exp(-Ds/theta.s1) + delta.1_tau2*(rho.1^Dt)/(1-rho.1^2)
  C2 =  diag(g, n)
  # K <- C0 + ( diag(X[,2]) %*% C1 %*% diag(X[,2]) ) + C2
  K <- C0 + C2
  ################################################################
  Ki <- solve(K)
  ldetK <- determinant(K, logarithm=TRUE)$modulus
  XKiX = t(X)%*%Ki%*%X
  XKiXi= solve( t(X)%*%Ki%*%X )
  XKiY = t(X)%*%Ki%*%Y
  ll = -(n/2)*log( t(Y - X %*% XKiXi %*% XKiY) %*% Ki %*% (Y - X %*% XKiXi %*% XKiY) ) -  (1/2)*ldetK
  counter <<- counter + 1
  return(-ll)
}


#############################################################
# 2011
#############################################################
y.spat.gp.pred.11 = y.spat.gp.pred.var.11 =  matrix(NA, T, S.11)


Bias.11 = EN.11 - WRF.11
for(i in 1:S.11){
  print(i)
  
  y = c(Bias.11[,-i])
  x = c(WRF.11[,-i])
  n = length(y)
  
  x1 = as.matrix(cbind(rep(1,n), (x)))
  x1.te = as.matrix(cbind(rep(1,24), (WRF.pred.11[,i])))
  
  
  d = location.11[-i,]
  ds = distance(d)
  
  # prediction
  d.te = location.11[i,]
  Ds.all = kronecker( distance(rbind(d,d.te)), ones(nT, nT) )
  Ds.tr = Ds.all[1:((S.11-1)*nT), 1:((S.11-1)*nT)]
  Ds.trte = Ds.all[((S.11-1)*nT+1):(S.11*nT), 1:((S.11-1)*nT)]
  Ds.tete = Ds.all[((S.11-1)*nT+1):(S.11*nT), ((S.11-1)*nT+1):(S.11*nT)]
  
  counter <- 0
  out <- optim(c(0.1, 1),
               nl,
               method="L-BFGS-B",
               lower=rep(eps,2),
               upper=c(Inf,Inf),
               Ds=Ds.tr,Y=y, X=x)
  length(out$par)
  out$par
  theta.s0 = out$par[1]
  g = out$par[2]
  
  ################################################################
  # Define the kernel or covariance function for training data
  C0 = exp(-Ds.tr/theta.s0) 
  C2 =  diag(g, n)
  K <- C0 + C2
  #####################################################################################################################
  # trte
  C0.trte = exp(-Ds.trte/theta.s0) 
  C.trte <- C0.trte 
  # te
  C0.tete = exp(-Ds.tete/theta.s0)
  C.tete <- C0.tete 
  
  
  ################################################################
  Ki = solve(K)
  ################################################################
  # Estimation of fixed effect (Mean of Y)
  beta.hat = solve( t((x1))%*% Ki%*% (x1) ) %*% t( (x1) ) %*% Ki %*% (y)
  beta.hat
  
  tau2 = 1/n * t((y)-x1%*% beta.hat) %*% Ki %*% ((y)-x1%*% beta.hat)
  tau2 = as.numeric(tau2)
  # Sigmai= Ki/tau2
  # tau2 = as.numeric(tau2)
  sigma2 = tau2 * g
  
  #####################################################################################################################
  # Mean of GP
  mean.Cn = C.trte %*% Ki %*% ((y)) +  x1.te %*% beta.hat
  #####################################################################################################################
  # original data
  y.hat = WRF.11[,i] + mean.Cn
  y.hat.var = tau2 * as.numeric(diag( C.tete - C.trte %*% Ki %*%  t(C.trte) )) + sigma2
  #############################################
  y.spat.gp.pred.11[,i] = y.hat
  y.spat.gp.pred.var.11[,i] = y.hat.var
}




plot(y.spat.gp.pred.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="Spatial GP")
for(i in 2:10){
  lines(y.spat.gp.pred.11[,i])
}



# proposed approach
rmse.spat_gp.11 = crps.spat_gp.11 = matrix(NA, S.11,1)
for(i in 1:S.11){
  rmse.spat_gp.11[i] = rmse( EN.11[,i], y.spat.gp.pred.11[,i] )
  crps.spat_gp.11[i] = crps( EN.11[,i], cbind(y.spat.gp.pred.11[,i],  sqrt(y.spat.gp.pred.var.11[,i])))$CRPS
}

# RMSE-2011
round(mean(rmse.spat_gp.11, na.rm=T),2)
round(sd(rmse.spat_gp.11, na.rm=T),2)
round(mean(crps.spat_gp.11, na.rm=T),2)
round(sd(crps.spat_gp.11, na.rm=T),2)
