par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
source("C:/Users/mapso/OneDrive/Desktop/research/bias correction/Final_code_data/Final_code/util/nl2.R")

library(zoo)
library(tibble)
library(Metrics)
library(verification)
library(base)
library(plgp)
library(ecodist)
library(mvtnorm)
library(lhs)
library(mda)
library(laGP)
library(zoo)
library(Matrix)
library(optimbase)
eps <- sqrt(.Machine$double.eps) ## defining a small number

################################
# remove missing / outlier data
################################
################################
# WRF.11 = yl.9
# EN.11 = yh.9[,1:10]

# WRF.11 = yl.10[61:100, 1:10]
# EN.11 = yh.10[61:100, 1:10]

WRF.11 = yl.11
EN.11 = yh.11


WRF.11 = yl.5
EN.11 = yh.5

################################
################################
location.11 = cbind(s1, s2)

S.11 = S
# location.11 = location.11[1:10, ]
# S.11 = 10
nT = T

#############################################################
# 2011
#############################################################

# y.pred.11 = y.pred.var.11 =  matrix(NA, 24, S.11)
y.spat.pred.11 = y.spat.pred.var.11 =  matrix(NA, nT, S.11)
# y.spat.pred.11 = y.spat.pred.var.11 =  matrix(NA, 40, S.11)


for(i in 1:S.11){
  print(i)
  
  y = c(WRF.11[,-i])
  n = length(y)
  d = location.11[-i,]
  ds = distance(d)
  dt = sqrt(distance(1:nT))
  Dt = kronecker(ones(ncol(ds),ncol(ds)), dt)
  
  # prediction
  d.te = location.11[i,]
  Ds.all = kronecker( distance(rbind(d,d.te)), ones(nT, nT) )
  Ds.tr = Ds.all[1:((S.11-1)*nT), 1:((S.11-1)*nT)]
  Ds.trte = Ds.all[((S.11-1)*nT+1):(S.11*nT), 1:((S.11-1)*nT)]
  Ds.tete = Ds.all[((S.11-1)*nT+1):(S.11*nT), ((S.11-1)*nT+1):(S.11*nT)]
  
  dt = sqrt(distance(t))
  Dt.all = kronecker(ones(S.11,S.11), dt)
  Dt.tr = Dt.all[1:((S.11-1)*nT), 1:((S.11-1)*nT)]
  Dt.trte = Dt.all[((S.11-1)*nT+1):(S.11*nT), 1:((S.11-1)*nT)]
  Dt.tete = Dt.all[((S.11-1)*nT+1):(S.11*nT), ((S.11-1)*nT+1):(S.11*nT)]
  
  counter <- 0
  out <- optim(rep(0.1,4),
  # out <- optim(c(1, 0.9, 5, 5),
               nl2,
               method="L-BFGS-B",
               lower=c(eps,eps,eps,eps),
               upper=c(Inf,1-eps,Inf,Inf),
               Ds=Ds.tr,Dt=Dt.tr,Y=y)
  
  length(out$par)
  out$par
  theta.s0 <- out$par[1]
  rho.0 = out$par[2]
  # theta.t0 = out$par[2]
  delta.0_tau2 = out$par[3]
  g <- out$par[4]
  
  ################################################################
  # Define the kernel or covariance function for training data
  C0 = exp(-Ds.tr/theta.s0) + delta.0_tau2*(rho.0^Dt.tr)/(1-rho.0^2)
  C2 =  diag(g, n)
  K <- C0 + C2
  #####################################################################################################################
  C.trte = exp(-Ds.trte/theta.s0) + delta.0_tau2*(rho.0^Dt.trte)/(1-rho.0^2)
  C.tete = exp(-Ds.tete/theta.s0) + delta.0_tau2*(rho.0^Dt.tete)/(1-rho.0^2)
  ################################################################
  Ki = solve(K)
  
  tau2 = 1/n * t(na.approx(y)) %*% Ki %*% (na.approx(y))
  tau2 = as.numeric(tau2)
  
  tau2.t0 = delta.0_tau2 * tau2
  sigma2 = tau2 * g
  #####################################################################################################################
  # Mean of GP
  mean.Cn = C.trte %*% Ki %*% (na.approx(y))
  #####################################################################################################################
  y.hat =  mean.Cn
  y.hat.var = tau2 * as.numeric(diag( C.tete - C.trte %*% Ki %*%  t(C.trte) )) + sigma2
  
  y.spat.pred.11[,i] = y.hat
  y.spat.pred.var.11[,i] = y.hat.var
}

WRF.pred.11 = y.spat.pred.11
WRF.pred.var.11 = y.spat.pred.var.11

# rm()
rmse(WRF.pred.11, WRF.11)
for(i in 1:S){
  plot(WRF.11[,i], ylim=c(-10, 10), main=i)
  lines(WRF.pred.11[,i], col=2)
}
head(WRF.pred.11)

save.image("C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/sim_study_x_v5.RData")
# 
# rm(list=setdiff(ls(), WRF.pred.11))
# rm(setdiff(ls(), WRF.pred.var.11))
