nl2 <- function(par, Ds, Dt, Y){
  n <- length(Y)
  Y = na.approx(Y)
  
  # spatial correlation: kernel width
  theta.s0 <- par[1]
  rho.0 = par[2]
  delta.0_tau2 = par[3]
  g <- par[4]
  ################################################################
  # Define the kernel or covariance function
  C0 = exp(-Ds/theta.s0) + delta.0_tau2*(rho.0^Dt)/(1-rho.0^2)
  C2 =  diag(g, n)
  K <- C0 + C2
  ################################################################
  Ki <- solve(K)
  ldetK <- determinant(K, logarithm=TRUE)$modulus
  ll = -(n/2)*log( t(Y) %*% Ki %*% Y ) -  (1/2)*ldetK
  counter <<- counter + 1
  return(-ll)
}