nl3 <- function(par, Ds, Dt, Y, X){
  n <- length(Y)
  Y = na.approx(Y)
  X = as.matrix(cbind(rep(1,n), na.approx(X)))
  length(par)
  
  # spatial correlation: kernel width
  theta.s0 <- par[1]  
  # temporal correlation: rho
  # theta.t0 <- par[2]  
  rho.0 = par[2]
  delta.0_tau2 = par[3]
  g <- par[4]
  
  ################################################################
  # Define the kernel or covariance function
  # C0 = exp(-Ds/theta.s0) + delta.0_tau2*exp(-Dt/theta.t0)
  C0 = exp(-Ds/theta.s0) + delta.0_tau2*(rho.0^Dt)/(1-rho.0^2)
  # C1 = tau2.1_tau2 * exp(-Ds/theta.s1) + delta.1_tau2*(rho.1^Dt)/(1-rho.1^2)
  C2 =  diag(g, n)
  K <- C0  + C2
  ################################################################
  Ki <- solve(K)
  ldetK <- determinant(K, logarithm=TRUE)$modulus
  XKiX = t(X)%*%Ki%*%X
  XKiXi= solve( t(X)%*%Ki%*%X )
  XKiY = t(X)%*%Ki%*%Y
  ll = -(n/2)*log( t(Y - X %*% XKiXi %*% XKiY) %*% Ki %*% (Y - X %*% XKiXi %*% XKiY) ) -  (1/2)*ldetK
  counter <<- counter + 1
  return(-ll)
}
